
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Data_sourcesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const data_sources = await db.data_sources.create(
            {
                id: data.id || undefined,
        
        source_type: data.source_type
        ||
        null
            ,
            
        institution_name: data.institution_name
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        imported_payload_json: data.imported_payload_json
        ||
        null
            ,
            
        imported_at: data.imported_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await data_sources.setDeclaration( data.declaration || null, {
            transaction,
        });
        
        await data_sources.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return data_sources;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const data_sourcesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                source_type: item.source_type
            ||
            null
            ,
            
                institution_name: item.institution_name
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                imported_payload_json: item.imported_payload_json
            ||
            null
            ,
            
                imported_at: item.imported_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const data_sources = await db.data_sources.bulkCreate(data_sourcesData, { transaction });

        // For each item created, replace relation files
        

        return data_sources;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const data_sources = await db.data_sources.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.source_type !== undefined) updatePayload.source_type = data.source_type;
        
        
        if (data.institution_name !== undefined) updatePayload.institution_name = data.institution_name;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.imported_payload_json !== undefined) updatePayload.imported_payload_json = data.imported_payload_json;
        
        
        if (data.imported_at !== undefined) updatePayload.imported_at = data.imported_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await data_sources.update(updatePayload, {transaction});

        
        
        if (data.declaration !== undefined) {
            await data_sources.setDeclaration(
              
              data.declaration,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await data_sources.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return data_sources;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const data_sources = await db.data_sources.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of data_sources) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of data_sources) {
                await record.destroy({transaction});
            }
        });


        return data_sources;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const data_sources = await db.data_sources.findByPk(id, options);

        await data_sources.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await data_sources.destroy({
            transaction
        });

        return data_sources;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const data_sources = await db.data_sources.findOne(
            { where },
            { transaction },
        );

        if (!data_sources) {
            return data_sources;
        }

        const output = data_sources.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        output.transactions_data_source = await data_sources.getTransactions_data_source({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.declaration = await data_sources.getDeclaration({
            transaction
        });
        
        
        output.organizations = await data_sources.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.declarations,
        as: 'declaration',
        
        where: filter.declaration ? {
          [Op.or]: [
            { id: { [Op.in]: filter.declaration.split('|').map(term => Utils.uuid(term)) } },
            {
              status: {
                [Op.or]: filter.declaration.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.institution_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'data_sources',
                        'institution_name',
                        filter.institution_name,
                    ),
                };
            }
            
            if (filter.imported_payload_json) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'data_sources',
                        'imported_payload_json',
                        filter.imported_payload_json,
                    ),
                };
            }
            

            
            

            
            if (filter.imported_atRange) {
                const [start, end] = filter.imported_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    imported_at: {
                    ...where.imported_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    imported_at: {
                    ...where.imported_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.source_type) {
                where = {
                    ...where,
                source_type: filter.source_type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.data_sources.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'data_sources',
                        'institution_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.data_sources.findAll({
            attributes: [ 'id', 'institution_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['institution_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.institution_name,
        }));
    }

    
};

